/***********************************************************************/
/*                                                                     */
/*  FILE        :player.c                                              */
/*  DATE        :Mon, May 24, 2010                                     */
/*  DESCRIPTION :Main Program                                          */
/*  CPU TYPE    :SH72620                                               */
/*                                                                     */
/*  This file is generated by Renesas Project Generator (Ver.4.16).    */
/*                                                                     */
/***********************************************************************/
                  
#include <stdio.h>
#include "../fatfs/ff.h"
#include "../fatfs/diskio.h"
#include "sys_ctrl.h"
#include "cmt_ctrl.h"
#include "led_ctrl.h"
#include "shuffle_play.h"
#ifdef USE_PWM
#include "pwm_ctrl.h"
#include "audio.h"
#ifdef LEVEL
#include "portg_ctrl.h"
#endif
#ifdef VOLUME
#include "adc_ctrl.h"
#endif
#endif
#ifdef USE_SSIF
#include "ssif_ctrl.h"
#endif
#ifdef USE_SPDIF
#include "spdif_ctrl.h"
#endif
#ifdef USE_SRC
#include "src_ctrl.h"
#endif
#ifdef USE_DMA
#include "dma_ctrl.h"
#endif
#ifdef USE_KEY
#include "key_ctrl.h"
#endif
#ifdef USE_PRINTF
#include "scif_ctrl.h"
#endif
#ifdef USE_CHECK
#include "check.h"
#endif


//#include "typedefine.h"
#ifdef __cplusplus
//#include <ios>                        // Remove the comment when you use ios
//_SINT ios_base::Init::init_cnt;       // Remove the comment when you use ios
#endif

void main(void);
#ifdef __cplusplus
extern "C" {
void abort(void);
}
#endif

void main(void)
{
	init_clk();
	cache_enable();
	resbank_enable();	/* HEWfobK̃j^ROMŐݒς݂ROMu[ĝ */

	init_led();
	init_cmt1();
	#ifdef USE_KEY
	init_key();
	#endif
	#ifdef USE_DMA
	init_dma();
	#endif
	#ifdef USE_SRC
	init_src();
	#endif
	#ifdef USE_SSIF
	init_ssif();
	#endif
	#ifdef USE_SPDIF
	init_spdif();
	#endif
	#ifdef USE_PWM
	init_cmt0();
	init_pwm();
	#ifdef LEVEL
	init_portg();
	#endif
	#ifdef VOLUME
	init_adc();
	#endif
	#endif
	#ifdef USE_PRINTF
	init_scif();
	#endif
	irq_enable();

	#ifdef USE_CHECK
	init_check();
	#endif

	printf("MP3 player SH-2A/CQ-Interface-2010\r\n");
	while(1)
	{
		if(0 == (disk_initialize(0) & (STA_NOINIT | STA_NODISK)))
		{
			FATFS fatfs;
			if(FR_OK == f_mount(0, &fatfs))
			{

				#ifdef USE_PWM
				cmt0_start();
				#endif
				led_on();
				while(1)
				{
					if(shuffle_play("\0"))break;
				}
				#ifdef USE_PWM
				cmt0_stop();
				#endif
			}
		}
		printf("disk error\r\n");
		delay_ms(1000);
		led_toggle();
	}
}

#ifdef __cplusplus
void abort(void)
{

}
#endif
