#include <stdio.h>

#include "iodefine.h"
#include "key_ctrl.h"
#ifdef USE_DMA
#include "dma_ctrl.h"
#endif

#ifdef HOKUTO
#define KEY1_MD		PORT.PHCR0.BIT.PH1MD
#define KEY2_MD		PORT.PHCR0.BIT.PH0MD
#define KEY1		PORT.PHPR0.BIT.PH1PR
#define KEY2		PORT.PHPR0.BIT.PH0PR
#endif
#ifdef WAKAMATSU
#define KEY1_MD 	PORT.PDCR0.BIT.PD0MD
#define KEY2_MD		PORT.PDCR0.BIT.PD1MD
#define KEY1		PORT.PDPR0.BIT.PD0PR
#define KEY2		PORT.PDPR0.BIT.PD1PR
#endif
#ifdef WAKAMATSU_LCD
#define KEY1_MD		PORT.PHCR0.BIT.PH0MD
#define KEY2_MD		PORT.PHCR0.BIT.PH1MD
#define KEY1		PORT.PHPR0.BIT.PH0PR
#define KEY2		PORT.PHPR0.BIT.PH1PR
#endif
#ifdef IF201008
#if 0
#define KEY1_MD		PORT.PGCR4.BIT.PG18MD
#define KEY2_MD 	PORT.PGCR4.BIT.PG19MD
#define KEY1		PORT.PGPR1.BIT.PG18PR
#define KEY2		PORT.PGPR1.BIT.PG19PR
#else
#define KEY1_MD		PORT.PHCR0.BIT.PH3MD
#define KEY2_MD 	PORT.PHCR0.BIT.PH2MD
#define KEY1		PORT.PHPR0.BIT.PH3PR
#define KEY2		PORT.PHPR0.BIT.PH2PR
#endif
#endif

#define KEY_ON	0
#define KEY_OFF	1

static int cmd_pause;
static int cmd_skip;

void init_key(void)
{
	KEY1_MD = 0;
	cmd_pause = 0;

	KEY2_MD = 0;
	cmd_skip = 0;

	return;
}

void key_event(void)
{
	{
		int key = KEY1;
		static int status = -1;

		switch(status)
		{
			case 0:
			case 1:
			case 2:
				status = (key == KEY_ON) ? status + 1 : 0;
				break;
			case 3:
				cmd_pause = cmd_pause == 0 ? 1 : 0;
				status = (key == KEY_ON) ? status + 1 : 0;
				break;
			default:
				status = (key == KEY_ON) ? status : 0;
				break;
		}
	}

	{
		int key = KEY2;
		static int status = -1;

		switch(status)
		{
			case 0:
			case 1:
			case 2:
				status = (key == KEY_ON) ? status + 1 : 0;
				break;
			case 3:
				cmd_skip = 1;
				status = (key == KEY_ON) ? status + 1 : 0;
				break;
			default:
				status = (key == KEY_ON) ? status : 0;
				break;
		}
	}

	return;
}

int key_cmd_chk(void)
{
	if(cmd_skip)
	{
		cmd_skip = 0;
		printf("skip\r\n");
		return 1;
	}

	if(cmd_pause)
	{
		printf("pause\r\n");
		#ifdef USE_DMA
		dma1_stop();
		#endif
		while(cmd_pause)
		{
			if(cmd_skip)
			{
				cmd_skip = 0;	/* |[ỸXLbv͖ */
			}
		}
		#ifdef USE_DMA
		dma1_start();
		#endif
		printf("continue\r\n");
	}

	return 0;
}
