#include <string.h>
#include <stdio.h>
#include <stdlib.h>

#include "iodefine.h"
#include "../fatfs/integer.h"
#include "../fatfs/diskio.h"
#include "../fatfs/ff.h"
#include "shuffle_play.h"
#include "play.h"

extern FIL fobj;
#define LIST_MAX 4096
static struct st_file_list {
	char sfn[127];
	char check;
} *file_list = (struct st_file_list *)(0x1c100000 - (sizeof(struct st_file_list) * LIST_MAX));
static int mp3_count;	/* ċAIɏ̂ŃO[oϐ */

static FRESULT make_list(char* dirname)
{
	FRESULT res;
	DIR Dir;
	FILINFO Finfo;

	res = f_opendir(&Dir, dirname);
	if(res) goto make_list_return;

	for( ; mp3_count < LIST_MAX; ) {
		res = f_readdir(&Dir, &Finfo);
		if(res != FR_OK) goto make_list_return;
		if(!Finfo.fname[0]) goto make_list_return;

		if(strstr(Finfo.fname, ".mp3") || strstr(Finfo.fname, ".MP3"))
		{
			strcpy(file_list[mp3_count].sfn, dirname);
			strcat(file_list[mp3_count].sfn, "\\");
			strcat(file_list[mp3_count].sfn, Finfo.fname);
			file_list[mp3_count].check = 0;
			printf("[%d]%s\r\n", mp3_count, file_list[mp3_count].sfn);
			mp3_count++;
		}else
		if(Finfo.fattrib & AM_DIR)
		{
			if(strcmp(Finfo.fname, "RECYCLER") && Finfo.fname[0] != '.')
			{
				char n[256];
				strcpy(n, dirname);
				strcat(n, "\\");
				strcat(n, Finfo.fname);
				make_list(n);
			}
		}
	}
make_list_return:
	return res;
}

FRESULT shuffle_play(char* dirname)
{
	int res;
	FILINFO Finfo;
	unsigned int n, count;

	printf("song list\r\n");
	mp3_count = 0;
	res = make_list(dirname);
	if(res != FR_OK) return res;

	printf("shuffle play start\r\n");
	for(count = 0; count < mp3_count; count++)
	{
		while(1)
		{
			n = (rand() + CMT.CMCNT1.WORD) % mp3_count;
			if(0 == file_list[n].check)
			{
				file_list[n].check = 1;
				printf("%d/%d[%d]%s\r\n", count, mp3_count, n, file_list[n].sfn);
				f_stat(file_list[n].sfn, &Finfo);
				res = play(file_list[n].sfn);
				if(res != FR_OK) return res;
				break;
			}
		}
	}
	return res;
}
