#include "iodefine.h"
#include "spdif_ctrl.h"

void init_spdif(void)
{
	/* SPDIF_ENM = 'H' */
	PORT.PCDR0.BIT.PC2DR	= 1;	/* SPDIF_EN 'H' */
	PORT.PCIOR0.BIT.PC2IOR	= 1;	/* PC2 o */
	PORT.PCCR0.BIT.PC2MD	= 0;	/* PC2 GPIO */

	PORT.PFCR3.BIT.PF12MD	= 5;	/* SPDIF_OUTI */
	CPG.STBCR7.BIT.MSTP76	= 0;	/* SPDIFփNbN */

	SPDIF.TLCS.LONG =
		(2<<28) |	/* CLAC		NbNx */
		(2<<24) |	/* FS		Tvg 0:44.1kHz 2:48kHz 3:32kHz */
		(1<<20) |	/* CHNO		`lԍ 1: 2:E */
		(0<<16) |	/* SRCNO	Mԍ */
		(0<< 8) |	/* CATCD	JeSR[h */
		(0<< 1) ;	/* CTL		Rg[ */
	SPDIF.TRCS.LONG =
		(2<<28) |	/* CLAC		NbNx */
		(2<<24) |	/* FS		Tvg 0:44.1kHz 2:48kHz 3:32kHz */
		(2<<20) |	/* CHNO		`lԍ 1: 2:E */
		(0<<16) |	/* SRCNO	Mԍ */
		(0<< 8) |	/* CATCD	JeSR[h */
		(0<< 1) ;	/* CTL		Rg[ */
	SPDIF.TUI  = 0;
	SPDIF.TLCA = 0x0000;	/* L ch f[^ */
	SPDIF.TRCA = 0x0000;	/* R ch f[^ */

	SPDIF.CTRL.BIT.CKS		= 0;	/* I[oTvNbNZNg */
	SPDIF.CTRL.BIT.PB		= 0;	/* pXobN */
	SPDIF.CTRL.BIT.RASS		= 0;	/* MW[I[fBITvrbgTCY */
	SPDIF.CTRL.BIT.TASS		= 0;	/* MW[I[fBITvrbgTCY */
	SPDIF.CTRL.BIT.RDE		= 0;	/* MW[DMACl[u */
	SPDIF.CTRL.BIT.TDE		= 0;	/* MW[DMACl[u */
	SPDIF.CTRL.BIT.NCSI		= 1;	/* V`lXe[^X: */
	SPDIF.CTRL.BIT.AOS		= 0;	/* I[fBII[Tv */
	SPDIF.CTRL.BIT.RME		= 0;	/* MW[Cl[u */
	SPDIF.CTRL.BIT.TME		= 1;	/* MW[Cl[u: */
	SPDIF.CTRL.BIT.REIE		= 0;	/* MW[G[݃Cl[u */
	SPDIF.CTRL.BIT.TEIE		= 0;	/* MW[G[݃Cl[u */
	SPDIF.CTRL.BIT.UBOI		= 0;	/* [Uobt@I[o݃Cl[u */
	SPDIF.CTRL.BIT.UBUI		= 0;	/* [Uobt@A_݃Cl[u */
	SPDIF.CTRL.BIT.CREI		= 0;	/* NbNJoG[݃Cl[u */
	SPDIF.CTRL.BIT.PAEI		= 0;	/* vAuG[݃Cl[u */
	SPDIF.CTRL.BIT.PREI		= 0;	/* peBG[݃Cl[u */
	SPDIF.CTRL.BIT.CSEI		= 0;	/* `lXe[^XG[݃Cl[u */
	SPDIF.CTRL.BIT.ABOI		= 0;	/* I[fBIobt@I[o݃Cl[u */
	SPDIF.CTRL.BIT.ABUI		= 0;	/* I[fBIobt@A_݃Cl[u */
	SPDIF.CTRL.BIT.RUII		= 0;	/* MW[[U񊄍݃Cl[u */
	SPDIF.CTRL.BIT.TUII		= 0;	/* MW[[U񊄍݃Cl[u */
	SPDIF.CTRL.BIT.RCSI		= 0;	/* MW[`lXe[^X݃Cl[u */
	SPDIF.CTRL.BIT.RCBI		= 0;	/* MW[`lobt@݃Cl[u */
	SPDIF.CTRL.BIT.TCSI		= 0;	/* MW[`lXe[^X݃Cl[u */
	SPDIF.CTRL.BIT.TCBI		= 1;	/* MW[`lobt@݃Cl[u */

	while(SPDIF.STAT.BIT.CSTX == 0 || SPDIF.STAT.BIT.TUIR == 0)
	{
		;
	}
	INTC.IPR16.BIT._SPDIF	= 1;	/* 荞ݗD惌xݒ */
	return;
}

/*  */
/* SRC0o̓WX^f[^SPDIFMW[̃I[fBIWX^ɏ */
void int_spdif_spdifi(void)
{
	if(1 == SPDIF.STAT.BIT.CBTX)
	{
		SPDIF.TLCA = SRC0.SRCOD.WORD.H;	/* SPDIF`l1ɍ̃I[fBIf[^ݒ */
		SPDIF.TRCA = SRC0.SRCOD.WORD.L;	/* SPDIF`l2ɉẼI[fBIf[^ݒ */
	}
	return;
}
